const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const trackingLocationService = require('./trackingLocation.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new gender
 * @param {Object} req.body - The gender data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created gender
 */
function create(req, res, next) {
    trackingLocationService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all genders
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of genders
 */
function getAll(req, res, next) {
    trackingLocationService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of gender objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of gender objects
 */
function option(req, res, next) {
    trackingLocationService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of genders matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of genders
 */
function count(req, res, next) {
    trackingLocationService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing gender
 * @param {number} req.params.id - The gender ID to be updated
 * @param {Object} req.body - The gender data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated gender
 */
function update(req, res, next) {
    trackingLocationService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a gender
 * @param {number} req.params.id - The gender ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    trackingLocationService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
